// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMIPars.pas' rev: 3.00

#ifndef SMIParsHPP
#define SMIParsHPP
#include <Classes.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Smipars
{
//-- type declarations -------------------------------------------------------
enum TTokenType { ttNone, ttString, ttNumeric, ttDateTime, ttParenthesis, ttOperation, ttParamDelimitor 
	};

typedef void __fastcall (__closure *TOnEvaluate)(System::TObject* Sender, System::AnsiString Eval, const 
	System::Variant * Args, const int Args_Size, int ArgCount, System::Variant &Value, bool &Done);

class DELPHICLASS TExpToken;
class PASCALIMPLEMENTATION TExpToken : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	System::AnsiString FText;
	TTokenType FTokenType;
	
public:
	__property System::AnsiString Text = {read=FText};
	__property TTokenType TokenType = {read=FTokenType, nodefault};
public:
	/* TObject.Create */ __fastcall TExpToken(void) : System::TObject() { }
	/* TObject.Destroy */ __fastcall virtual ~TExpToken(void) { }
	
};

class DELPHICLASS TExpParser;
class PASCALIMPLEMENTATION TExpParser : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	System::AnsiString FExpression;
	Classes::TList* FTokens;
	int FPos;
	
private:
	void __fastcall Clear(void);
	TExpToken* __fastcall GetToken(int Index);
	void __fastcall SetExpression(const System::AnsiString Value);
	
public:
	__fastcall TExpParser(void);
	__fastcall virtual ~TExpParser(void);
	TExpToken* __fastcall ReadFirstToken(void);
	TExpToken* __fastcall ReadNextToken(void);
	int __fastcall TokenCount(void);
	__property TExpToken* Tokens[int Index] = {read=GetToken};
	__property Classes::TList* TokenList = {read=FTokens};
	__property System::AnsiString Expression = {read=FExpression, write=SetExpression};
};

class DELPHICLASS TExpNode;
class PASCALIMPLEMENTATION TExpNode : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	System::TObject* FOwner;
	TExpNode* FParent;
	Classes::TList* FChildren;
	Classes::TList* FTokens;
	int FLevel;
	TExpToken* FToken;
	TOnEvaluate FOnEvaluate;
	
private:
	TExpToken* __fastcall GetToken(int Index);
	TExpNode* __fastcall GetChildren(int Index);
	int __fastcall FindLSOTI(void);
	bool __fastcall ParseFunction(void);
	void __fastcall RemoveSorroundingParenthesis(void);
	void __fastcall SplitToChildren(int TokenIndex);
	System::Variant __fastcall Evaluate();
	__property TExpNode* Children[int Index] = {read=GetChildren};
	
public:
	__fastcall TExpNode(System::TObject* AOwner, TExpNode* AParent, Classes::TList* Tokens);
	__fastcall virtual ~TExpNode(void);
	void __fastcall Build(void);
	int __fastcall TokenCount(void);
	System::Variant __fastcall Calculate();
	__property TExpToken* Tokens[int Index] = {read=GetToken};
	__property TExpNode* Parent = {read=FParent};
	__property int Level = {read=FLevel, nodefault};
	__property TOnEvaluate OnEvaluate = {read=FOnEvaluate, write=FOnEvaluate};
};

class DELPHICLASS TSMIParser;
class PASCALIMPLEMENTATION TSMIParser : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool FProcessBeforeEvent;
	System::AnsiString FText;
	TOnEvaluate FOnEvaluate;
	System::Variant FValue;
	
protected:
	void __fastcall Compile(void);
	System::Variant __fastcall GetValue();
	void __fastcall Evaluate(System::AnsiString Eval, const System::Variant * Args, const int Args_Size
		, System::Variant &Value);
	
public:
	__fastcall virtual TSMIParser(Classes::TComponent* AOwner);
	__property System::Variant Value = {read=GetValue};
	
__published:
	__property bool ProcessBeforeEvent = {read=FProcessBeforeEvent, write=FProcessBeforeEvent, nodefault
		};
	__property System::AnsiString Text = {read=FText, write=FText};
	__property TOnEvaluate OnEvaluate = {read=FOnEvaluate, write=FOnEvaluate};
public:
	/* TComponent.Destroy */ __fastcall virtual ~TSMIParser(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE System::TDateTime __fastcall GetDTByMask(System::AnsiString AValue, System::AnsiString 
	AFormat, char ADateSeparator, char ATimeSeparator);
extern PACKAGE bool __fastcall StringIsNumeric(System::AnsiString Value);

}	/* namespace Smipars */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Smipars;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// SMIPars
