unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, DBGrids, Db, DBTables, SMIBase, SMI2XML;

type
  TfrmMain = class(TForm)
    tblCountry: TTable;
    dSrcCountry: TDataSource;
    DBGrid1: TDBGrid;
    btnLoad: TButton;
    btnAbout: TButton;
    btnClose: TButton;
    lblWWW: TLabel;
    SMImportFromXML1: TSMImportFromXML;
    procedure btnLoadClick(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.btnLoadClick(Sender: TObject);
begin
  {update records from xml instead existing}
  SMImportFromXML1.Mode := imAppendUpdate;

  {define the uniqye field(s)}
  SMImportFromXML1.DatasetKeys := 'Name';

  {correspindence between fields and parsed columns}
  SMImportFromXML1.Mappings.Clear;
  SMImportFromXML1.Mappings.Add('Name=Name');
  SMImportFromXML1.Mappings.Add('Capital=Capital');
  SMImportFromXML1.Mappings.Add('Continent=Continent');
  SMImportFromXML1.Mappings.Add('Area=Area');
  SMImportFromXML1.Mappings.Add('Population=Population');

  {file name}
  SMImportFromXML1.SourceFileName := ExtractFilePath(Application.ExeName) + 'country.xml';

  {specify custom formats}
  SMImportFromXML1.DataFormats.DecimalSeparator := '.';

  {start a process}
  SMImportFromXML1.Execute;
end;

procedure TfrmMain.btnAboutClick(Sender: TObject);
begin
  SMImportFromXML1.AboutSMI
end;

procedure TfrmMain.btnCloseClick(Sender: TObject);
begin
  Close
end;

end.
